<script lang="ts">
  import { getNotifyAPI } from "src/apis/get-notify";
  import { updateNotifyAPI } from "src/apis/update-notify";
  import { convertFullTime } from "src/functions/convert-time-th";
  import type { NotifyModel } from "src/models/notify.type";
  import { notifyStore, userProfileStore } from "src/store";
  import { onMount } from "svelte";
  import { fade } from "svelte/transition";

  let showMenu = false;
  let timeOutSubscribe: any = null;

  $: notifyUnread = $notifyStore.filter((noty) => noty["readed"] == false);

  onMount(async () => {
    if ($userProfileStore.userId) {
      await getNotifyAPI($userProfileStore.userId);
    }
  });

  function onMouseOut() {
    timeOutSubscribe = setTimeout(function () {
      showMenu = false;
    }, 2000);
  }

  function onMouseOver() {
    showMenu = true;
    clearTimeout(timeOutSubscribe);
  }

  async function onReading(notify: NotifyModel) {
    notify.readed = true;
    await updateNotifyAPI(notify);
    await getNotifyAPI($userProfileStore.userId);
  }
</script>

<div class="flex flex-1 justify-end items-center leading-2 text-gray-800 mx-2">
  <div
    on:mouseenter={() => (showMenu = true)}
    on:mouseleave={onMouseOut}
    class="relative text-gray-800"
  >
    <div role="button" aria-describedby="stardust-popover2" class="">
      <div class="flex items-center py-2 px-0 h-full">
        <div
          class="flex items-center m-0 text-indigo-700 no-underline bg-transparent cursor-pointer"
          id="options-menu"
          aria-expanded="true"
          aria-haspopup="true"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            class="h-6 w-6 text-white"
            fill="none"
            viewBox="0 0 24 24"
            stroke="currentColor"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M15 17h5l-1.405-1.405A2.032 2.032 0 0118 14.158V11a6.002 6.002 0 00-4-5.659V5a2 2 0 10-4 0v.341C7.67 6.165 6 8.388 6 11v3.159c0 .538-.214 1.055-.595 1.436L4 17h5m6 0v1a3 3 0 11-6 0v-1m6 0H9"
            />
          </svg>

          {#if notifyUnread?.length}
            <div
              class="relative py-0 px-2 -mr-5 h-5 leading-5 text-center bg-red-500 text-white border-solid rounded-full"
              style="border-radius: 44px; min-width: 0.6875rem; left: -1.25rem; top: -0.6875rem;"
            >
              {notifyUnread?.length || ""}
            </div>
          {/if}
        </div>
      </div>
    </div>
  </div>
</div>

{#if showMenu && $notifyStore && $notifyStore.length > 0}
  <div
    transition:fade
    on:mouseenter={onMouseOver}
    on:mouseleave={() => (showMenu = false)}
    class="rounded"
  >
    <div
      class="origin-top-right absolute right-0 mt-5 mr-12 w-80 rounded shadow-lg bg-white ring-1 ring-black ring-opacity-5 focus:outline-none"
      role="menu"
      aria-orientation="vertical"
      aria-labelledby="options-menu"
    >
      <div
        class="relative w-0 h-0 leading-4 text-gray-800 border-transparent border-solid"
        style="border-bottom: 10px solid rgb(255, 255, 255); border-left: 14px solid transparent; border-right: 14px solid transparent; bottom: 10px; left: 275px;"
      />

      <div
        class="flex items-center pl-2 h-10 leading-4 text-gray-500 capitalize"
      >
        การแจ้งเดือนล่าสุด
      </div>
      {#each $notifyStore as notify}
        <div
          class="{!notify.readed
            ? 'bg-gray-200'
            : ''} text-gray-600 flex relative p-2 w-full leading-4 box-border border-b"
        >
          <!-- <img
            alt="productImg"
            class="flex-shrink-0 w-5 h-5 text-gray-800 bg-no-repeat bg-cover border border-gray-300 border-solid"
            src={notify.image}
          /> -->
          <div class="overflow-hidden flex-1 ml-2">
            <div class="flex items-center">
              <div class="font-medium flex flex-col">
                <div>{@html notify?.description || "-"}</div>
                <div
                  class=" text-xs mt-2 {!notify.readed
                    ? 'text-gray-600'
                    : 'text-gray-400'}"
                >
                  {convertFullTime(notify.timeStamp)}
                </div>
              </div>
              <div class="flex-1" />
              {#if !notify.readed}
                <div class="flex justify-end">
                  <button
                    on:click={() => onReading(notify)}
                    class="bg-blue-500 rounded px-2 py-1 text-white"
                    >อ่าน</button
                  >
                </div>
              {/if}
            </div>
          </div>
        </div>
      {/each}
      <div
        class="flex items-center p-2 h-10 text-xs leading-10 text-center text-gray-800 capitalize bg-white"
      >
        <div class="flex-1 leading-10 text-gray-800 capitalize" />
      </div>
    </div>
  </div>
{/if}
